unit uMain;

{$mode objfpc}{$H+}

interface

uses
  Windows, Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, Menus, ComCtrls, Grids;

const
  WM_UPDATEGAUGE = WM_USER + $101;

type
  TWordByte = array [0..1] of Byte;

  { TfrmFordDiag }

  TfrmFordDiag = class(TForm)
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    btnToCommon: TButton;
    btnToCommon1: TButton;
    btnToFuel: TButton;
    btnToFuel1: TButton;
    btnToFuel2: TButton;
    btnToSensor: TButton;
    btnToSensor1: TButton;
    btnToSensor2: TButton;
    Label1: TStaticText;
    Label10: TStaticText;
    Label12: TStaticText;
    Label13: TStaticText;
    Label14: TStaticText;
    Label15: TStaticText;
    Label16: TStaticText;
    Label17: TStaticText;
    Label18: TStaticText;
    Label19: TStaticText;
    Label20: TStaticText;
    Label21: TStaticText;
    Label22: TStaticText;
    Label23: TStaticText;
    Label24: TStaticText;
    Label26: TStaticText;
    Label27: TStaticText;
    Label3: TStaticText;
    Label7: TStaticText;
    Label8: TStaticText;
    Label9: TStaticText;
    lbACT: TStaticText;
    lbAvg: TStaticText;
    lbAvg5min: TStaticText;
    lbAvgCap: TStaticText;
    lbAvgSpeed: TStaticText;
    lbCur: TStaticText;
    lbDSDRPM: TStaticText;
    lbECT: TStaticText;
    lbACClutch: TStaticText;
    lbPowerStr: TStaticText;
    lbFUELPW1: TStaticText;
    lbIEGO1: TStaticText;
    lbISCDTY: TStaticText;
    lbITP: TStaticText;
    lbLAMBSE1: TStaticText;
    lbMAF: TStaticText;
    lbN: TStaticText;
    lbOdo: TStaticText;
    lbSAFTOT: TStaticText;
    lbVBAT: TStaticText;
    lbVer: TStaticText;
    lbLoop: TStaticText;
    lbFuelPump: TStaticText;
    lbCanister: TStaticText;
    lbh: TStaticText;
    lbVS: TStaticText;
    lbVS2: TStaticText;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    menuCommon: TMenuItem;
    menuFuel: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    menuSensor: TMenuItem;
    NB: TNotebook;
    pbLOAD: TProgressBar;
    pgFaults: TPage;
    pgFuel: TPage;
    pb0: TProgressBar;
    pb1: TProgressBar;
    pb10: TProgressBar;
    pb11: TProgressBar;
    pb2: TProgressBar;
    pb3: TProgressBar;
    pb4: TProgressBar;
    pb5: TProgressBar;
    pb6: TProgressBar;
    pb7: TProgressBar;
    pb8: TProgressBar;
    pb9: TProgressBar;
    pgCommon: TPage;
    pgSensor: TPage;
    pbITP: TProgressBar;
    sgFaults: TStringGrid;
    tm: TTimer;
    tm1: TTimer;
    procedure Bevel3ChangeBounds(Sender: TObject);
    procedure btnTestClick(Sender: TObject);
    procedure btnToCommonClick(Sender: TObject);
    procedure btnToFuelClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lbAvgClick(Sender: TObject);
    procedure menuCommonClick(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure pnFuelClick(Sender: TObject);
    procedure tm1Timer(Sender: TObject);
    procedure tmTimer(Sender: TObject);
  private
    { private declarations }
    FCom: THandle;
    //
    dataBuff: TWordByte;
    dataOffs: Byte;
    dataSync: Byte;
    //
    NumFuel, NumSpeed, NumFuel5min, NumSpeed5min: Integer;
    function VPCheck(Data: TWordByte): Boolean;
    procedure CalcFuel;
    procedure ExecuteRcv;
    procedure ExecuteFaults;
    procedure WMUpdateGauge(var Msg: TMessage); message WM_UPDATEGAUGE;
    procedure UpdateCommon(AID: Byte);
    procedure UpdateSensor(AID: Byte);
    procedure UpdateFuel(AID: Byte);
    //
 public
    { public declarations }
    FrameMap: array [0..255] of Word;
    UpdateCnt, OdoCnt: Cardinal;
    CurCons, AvgFuel, AvgSpeed, AvgFuel5min, AvgSpeed5min: Single;
//    RCV: TRcvThread;
    Odo: Single;
  end;

const
  LOCK_SESSION: DWORD            = 1;
  HOME_SESSION: DWORD            = 2;
  FLUSH_SESSION: DWORD           = 4;
  IDLE_SESSION: DWORD            = 8;

function SHIdleTimerResetEx(dwFlags: DWORD): HRESULT; stdcall; external 'aygshell.dll';
procedure SystemIdleTimerReset; stdcall; external 'coredll.dll';



var
  frmFordDiag: TfrmFordDiag;

implementation

{$ifdef LCLWinCE}
uses
  WinCEInt;
{$endif}

{ TfrmFordDiag }

procedure TfrmFordDiag.btnTestClick(Sender: TObject);
var
  commDCB: TDCB;
begin
  //
  FCom := CreateFileW(PWideChar('COM1:'), GENERIC_READ + GENERIC_WRITE, 0, nil, OPEN_EXISTING,
   FILE_ATTRIBUTE_NORMAL, 0);
  lbh.Caption := IntToStr(FCom);
  if (FCom = INVALID_HANDLE_VALUE) then lbh.Caption := 'Error!'
  else
  begin
    if (GetCommState(FCom, commDCB)) then
    // Can we change the baud rate? Let's check the commProp
    //  if (commDCB.dwSettableParams and SP_BAUD > 0) then
      begin
        commDCB.BaudRate := CBR_38400;
        commDCB.Parity := NOPARITY;
        commDCB.StopBits := ONESTOPBIT;
        commDCB.ByteSize := 8;

        if SetCommState(FCom, commDCB) then
          lbh.Caption := 'OK!';
        Application.ProcessMessages;
        Sleep(200);
        tm.Enabled:=true;
        tm1.Enabled:=True;
        if NB.PageIndex = 0 then
          ExecuteFaults
        else
          ExecuteRcv;
      end;
  end;
  {RCV := TRcvThread.Create(True);
  RCV.Priority:= tpHighest;
  RCV.ComHandle:=FCom;
  RCV.Resume; }
//keybd_event(VK_F24, 0, KEYEVENTF_KEYUP or KEYEVENTF_SILENT, 0);
end;

procedure TfrmFordDiag.Bevel3ChangeBounds(Sender: TObject);
begin
end;

procedure TfrmFordDiag.btnToCommonClick(Sender: TObject);
begin
  if NB.PageIndex < Pred(NB.PageCount) then
    NB.PageIndex:=NB.PageIndex+1
  else
    NB.PageIndex:=1;
end;

procedure TfrmFordDiag.btnToFuelClick(Sender: TObject);
begin
  if NB.PageIndex > 1 then
    NB.PageIndex:=NB.PageIndex-1
  else
    NB.PageIndex:=Pred(NB.PageCount);
end;

procedure TfrmFordDiag.Button2Click(Sender: TObject);
begin
   //RCV.Terminate;
   lbh.Caption:='Closed';
   tm.Enabled:=False;
   tm1.Enabled:=false;
   CloseHandle(FCom);
end;

procedure TfrmFordDiag.FormCreate(Sender: TObject);
begin
  Color := clBlack;
  SysUtils.DecimalSeparator:='.';
  FCom := 0;
  NB.PageIndex := 0;
end;

procedure TfrmFordDiag.lbAvgClick(Sender: TObject);
begin
  (Sender as TStaticText).Visible:= False;
  if Sender = lbAvg then
    lbAvg5Min.Visible:= True
  else
    lbAvg.Visible:= True;
  (Sender as TStaticText).SendToBack;
end;

procedure TfrmFordDiag.menuCommonClick(Sender: TObject);
begin
end;

procedure TfrmFordDiag.MenuItem1Click(Sender: TObject);
begin

end;

procedure TfrmFordDiag.MenuItem3Click(Sender: TObject);
begin
  NB.PageIndex:=0;
end;

procedure TfrmFordDiag.pnFuelClick(Sender: TObject);
begin

end;

procedure TfrmFordDiag.tm1Timer(Sender: TObject);
begin
  pb0.Position:=pb1.Position;
  pb1.Position:=pb2.Position;
  pb2.Position:=pb3.Position;
  pb3.Position:=pb4.Position;
  pb4.Position:=pb5.Position;
  pb5.Position:=pb6.Position;
  pb6.Position:=pb7.Position;
  pb7.Position:=pb8.Position;
  pb8.Position:=pb9.Position;
  pb9.Position:=pb10.Position;
  pb10.Position:=pb11.Position;
  AvgFuel5Min := 0;
  NumFuel5Min := 0;
  AvgSpeed5min := 0;
  NumSpeed5Min := 0;
end;

procedure TfrmFordDiag.tmTimer(Sender: TObject);
begin
  //
  keybd_event(VK_F24, 0, KEYEVENTF_KEYUP or KEYEVENTF_SILENT, 0);
  // odometer
  lbOdo.Caption:=Format('%.1f', [Odo]);
 try
//
 except
 end;
end;

function TfrmFordDiag.VPCheck(Data: TWordByte): Boolean;
begin
  Result := (Data[1] shr 4) and $F = (Data[0] and $F) xor ((Data[0] shr 4) and $F) xor (Data[1] and $F) xor $A;
end;

procedure TfrmFordDiag.CalcFuel;
var
  fuel, rpm: word;
  afuel, vs: single;
begin
  vs := (FrameMap[dataOffs] and $FFF) * 0.03125 * 1.609344;
  // odo calc
  Odo := Odo + (GetTickCount - UpdateCnt) / 1000 / 60 / 60 * vs;
  lbh.Caption:=IntToStr(GetTickCount - UpdateCnt);
  UpdateCnt := GetTickCount;
  // calc fuel consumption
  if (dataOffs = $63) then
  begin
    rpm := (FrameMap[$02] and $FFF) * 4;
    fuel := FrameMap[$32] and $FFF;
  end
  else
  begin
    rpm := (FrameMap[$82] and $FFF) * 4;
    fuel := FrameMap[$B2] and $FFF;
  end;
  //if vs > 0 then
  AvgSpeed := (AvgSpeed * NumSpeed + vs) / (NumSpeed + 1);
  Inc(NumSpeed);
  AvgSpeed5min := (AvgSpeed5min * NumSpeed5min + vs) / (NumSpeed5min + 1);
  Inc(NumSpeed5min);
  // l/h
  if rpm > 0 then
  begin
    afuel := 191.3 * 0.06 * fuel * 2 * 3 / 26 / (60000 / rpm);
    AvgFuel := (AvgFuel * NumFuel + afuel) / (NumFuel + 1);
    Inc(NumFuel);
    AvgFuel5min := (AvgFuel5min * NumFuel5min + afuel) / (NumFuel5min + 1);
    Inc(NumFuel5min);
    if vs < 5 then
      CurCons := afuel
    else
      CurCons := 100 * afuel / vs;
    // now sync to main form
  end; //rpm
end;

procedure TfrmFordDiag.ExecuteRcv;
const
 // cmdR: string[2] = 'r'#13;
  cmdE: string[3] = 'cE'#13;
  cmdG: string[3] = 'cG'#13;
  cmdV: string[2] = 'v'#13;
  cmdZ: string[2] = 'z'#13;
var
  bw, br: LongWord;
  i: integer;
  commTimeOut: TCOMMTIMEOUTS;
  buf: array [1..500] of Byte;
begin
  bw := 0; br :=0;
  ZeroMemory(@buf, sizeof(buf));
  Zeromemory(@commTimeOut, sizeof(commTimeOut));
  GetCommTimeouts(FCom, commTimeOut);
  commTimeOut.ReadIntervalTimeout := 100;
  commTimeOut.ReadTotalTimeoutConstant := 1000;
  commTimeOut.ReadTotalTimeoutMultiplier := 11;

  SetCommTimeouts(FCom, commTimeOut);

  if not WriteFile(FCom, cmdZ[1], 2, bw, nil) then frmFordDiag.lbh.Caption := 'Error reset!';
  if ReadFile(FCom, buf, 1, bw, nil) then
  begin
    lbVer.Caption:= PChar(@buf);//Format('%.2f', [StrToIntDef(copy(PChar(@buf), 1, 4), 0) / 100]);
  end;
  Application.ProcessMessages;
  Sleep(400);
  PurgeComm(FCom, PURGE_RXCLEAR);
  ZeroMemory(@buf, 500);
  if not WriteFile(FCom, cmdV[1], 2, bw, nil) then frmFordDiag.lbh.Caption := 'Error version!';
  if ReadFile(FCom, buf, 4, bw, nil) then
  begin
    lbVer.Caption:= PChar(@buf);//Format('%.2f', [StrToIntDef(copy(PChar(@buf), 1, 4), 9999) / 100]);
  end;
  PurgeComm(FCom, PURGE_RXCLEAR);

  if not WriteFile(FCom, cmdE[1], 3, bw, nil) then frmFordDiag.lbh.Caption := 'Error!';
  Sleep(300);
  PurgeComm(FCom, PURGE_RXCLEAR);
  if WriteFile(FCom, cmdG[1], 3, bw, nil) then frmFordDiag.lbh.Caption := 'Read!';
  dataSync := 2;
  repeat  // main cycle
    Application.ProcessMessages;
    if ReadFile(FCom, buf, 500, br, nil) then
    begin
      for i := 1 to br do
      begin
        if (buf[i] = $FF) and (dataSync > 1) then
        begin
          dataSync := 0;
          dataOffs := $FF;
        end
        else
        begin
          if dataOffs = $FF then
            dataOffs := buf[i]
          else
          begin
            if dataSync < 2 then dataBuff[dataSync] := buf[i];
            Inc(dataSync);

            if dataSync = 2 then
            begin
              if VPCheck(dataBuff) then
              begin
                CopyMemory(@FrameMap[dataOffs], @dataBuff, 2);
                if (dataOffs = $63) or (dataOffs = $E3) then
                  CalcFuel;
                PostMessage(Handle, WM_UPDATEGAUGE, dataOffs, 0);
              end else dataSync := 2; // lost sync
            end;
          end;
        end;
      end;
    end else Break;
    Application.ProcessMessages;
  until not tm.Enabled;
end;

procedure TfrmFordDiag.ExecuteFaults;
const
  cmdB: string[3] = 'cB'#13;
  cmdC: string[3] = 'cC'#13;
  cmdZ: string[2] = 'z'#13;
var
  bw, br: LongWord;
  i, j, c: integer;
  commTimeOut: TCOMMTIMEOUTS;
  buf: array [1..500] of Byte;
begin
  bw := 0; br :=0;
  ZeroMemory(@FrameMap, sizeof(FrameMap));
  ZeroMemory(@buf, sizeof(buf));
  Zeromemory(@commTimeOut, sizeof(commTimeOut));
  GetCommTimeouts(FCom, commTimeOut);
  commTimeOut.ReadIntervalTimeout := 50;
  commTimeOut.ReadTotalTimeoutConstant := 0;
  commTimeOut.ReadTotalTimeoutMultiplier := 1;

  SetCommTimeouts(FCom, commTimeOut);

  if not WriteFile(FCom, cmdZ[1], 2, bw, nil) then frmFordDiag.lbh.Caption := 'Error reset!';
  Sleep(400);
  PurgeComm(FCom, PURGE_RXCLEAR);

  if WriteFile(FCom, cmdB[1], 3, bw, nil) then frmFordDiag.lbh.Caption := 'Read!';
  dataSync := 2;
  repeat  // main cycle
    Application.ProcessMessages;
    if ReadFile(FCom, buf, 500, br, nil) then
    begin
      for i := 1 to br do
      begin
        if (buf[i] = $FF) and (dataSync > 1) then
        begin
          dataSync := 0;
          dataOffs := $FF;
        end
        else
        begin
          if dataOffs = $FF then
            dataOffs := buf[i]
          else
          begin
            if dataSync < 2 then dataBuff[dataSync] := buf[i];
            Inc(dataSync);

            if dataSync = 2 then
            begin
              if VPCheck(dataBuff) then
              begin
                CopyMemory(@FrameMap[dataOffs], @dataBuff, 2);
              end else dataSync := 2; // lost sync
            end;
          end;
        end;
      end;
    end else Break;
    Application.ProcessMessages;
  until (br = 0);
  // now we have faults in FrameMap
  c := 1;
  for i := $0E downto 2 do
    for j := 0 to $F do
      if FrameMap[j shl 4 + i] > 0 then
      begin
        sgFaults.Cells[0, c] := IntToHex(FrameMap[j shl 4 + i] and $FFF, 3);
        Inc(c);
      end;
end;

procedure TfrmFordDiag.WMUpdateGauge(var Msg: TMessage);
begin
  //
  case Msg.wParam of
    $43, $C3:
      begin
        if FrameMap[Msg.wParam] and $0400 = $0400 then
          lbCanister.Color := clLime
        else
          lbCanister.Color := clGray;
        if FrameMap[Msg.wParam] and $80 = $80 then
          lbFuelPump.Color := clLime
        else
          lbFuelPump.Color := clGray;
        if FrameMap[Msg.wParam] and $0800 = $0800 then
          lbACClutch.Color := clGray
        else
          lbACClutch.Color := clLime;
      end;
    $44, $C4:
      begin
        if FrameMap[Msg.wParam] and $01 = $01 then
          lbLoop.Color := clGray
        else
          lbLoop.Color := clLime;
        if FrameMap[Msg.wParam] and $02 = $02 then
          lbPowerStr.Color := clLime
        else
          lbPowerStr.Color := clGray;
      end;
  end;
  case NB.PageIndex of
    1: UpdateCommon(Msg.wParam);
    2: UpdateSensor(Msg.wParam);
    3: UpdateFuel(Msg.wParam);
  end;
end;

procedure TfrmFordDiag.UpdateCommon(AID: Byte);
begin
  case AID of
    $02, $82: lbN.Caption:= Format('%d', [(FrameMap[AID] and $FFF) * 4]);
    $03, $83: lbVBAT.Caption:= Format('%.1f', [(FrameMap[AID] and $FFF) * 0.0625]);
    $04, $84: lbITP.Caption:= Format('%d', [FrameMap[AID] and $FFF]);
    $32, $B2: lbFUELPW1.Caption:= Format('%.1f', [(FrameMap[AID] and $FFF) / 8.667]);
    $63, $E3: lbVS.Caption:= Format('%.0f', [(FrameMap[AID] and $FFF) * 0.03125 * 1.609344]);
    $74, $F4: lbDSDRPM.Caption:= Format('%d', [(FrameMap[AID] and $FF) * 16]);
    $23, $A3: lbISCDTY.Caption:= Format('%d', [(FrameMap[AID] and $FFF)]);
  end;
end;

procedure TfrmFordDiag.UpdateSensor(AID: Byte);
begin
  case AID of
    $14, $94: lbECT.Caption:= Format('%.1f', [ ((FrameMap[AID] and $FF) * 2 - 32) * 5 / 9]);
    $22, $A2: lbACT.Caption:= Format('%.1f', [ ((FrameMap[AID] and $FF) * 2 - 32) * 5 / 9]);
    $24, $A4: lbMAF.Caption:= Format('%d', [(FrameMap[AID] and $FFF)]);
    $34, $B4: lbIEGO1.Caption:= Format('%d', [(FrameMap[AID] and $FFF)]);
    $05, $85: lbLAMBSE1.Caption:= Format('%.1f', [(FrameMap[AID] and $FFF) / 2048]);
    $33, $B3: lbSAFTOT.Caption:= Format('%.1f', [(FrameMap[AID] and $FF) * 0.25]);
  end;
end;

procedure TfrmFordDiag.UpdateFuel(AID: Byte);
begin
  case AID of
    $04, $84: pbITP.Position:= FrameMap[AID] and $FFF;
    $72, $F2: pbLOAD.Position:= Round((FrameMap[AID] and $FFF)*0.0488);
    $63, $E3:
      begin
        lbVS2.Caption:= Format('%.0f', [(FrameMap[AID] and $FFF) * 0.03125 * 1.609344]);
        lbAvgSpeed.Caption:=Format('%.1f', [AvgSpeed]);
        lbCur.Caption:=Format('%.1f', [CurCons]);
        if AvgSpeed > 0 then
        begin
          lbAvg.Caption:=Format('%.1f', [AvgFuel * 100 / AvgSpeed]);
          if (AvgSpeed5min > 0) then
          begin
            lbAvg5min.Caption:=Format('%.1f', [AvgFuel5min * 100 / AvgSpeed5min]);
            pb11.Position:= Round((AvgFuel5min * 100 / AvgSpeed5min) * 100 / 15);
          end;
        end;
      end;
  end;
end;

initialization
  {$I umain.lrs}
{$ifdef LCLWinCE}
  WinCEWidgetset.WinCETitlePolicy := tpOKButtonOnlyOnDialogs;
{$endif}

end.

